From a3d64b963aee827de96b7cdf4bd049f28c5cf596 Mon Sep 17 00:00:00 2001
From: Paul Marillonnet <pmarillonnet@entrouvert.com>
Date: Sun, 18 Apr 2021 10:38:22 +0200
Subject: [PATCH] templates: load static library using {% load static %}
 (#53227)

---
 src/authentic2/manager/templates/authentic2/manager/base.html   | 2 +-
 .../manager/templates/authentic2/manager/ou_common.html         | 2 +-
 src/authentic2/manager/templates/authentic2/manager/ous.html    | 2 +-
 .../manager/templates/authentic2/manager/role_common.html       | 2 +-
 .../manager/templates/authentic2/manager/role_members.html      | 2 +-
 .../manager/templates/authentic2/manager/role_permissions.html  | 2 +-
 src/authentic2/manager/templates/authentic2/manager/roles.html  | 2 +-
 .../manager/templates/authentic2/manager/service.html           | 2 +-
 .../manager/templates/authentic2/manager/services.html          | 2 +-
 .../templates/authentic2/manager/user_authorizations.html       | 2 +-
 .../manager/templates/authentic2/manager/user_detail.html       | 2 +-
 .../manager/templates/authentic2/manager/user_export.html       | 2 +-
 .../manager/templates/authentic2/manager/user_import.html       | 2 +-
 .../templates/authentic2/manager/user_import_report.html        | 2 +-
 .../manager/templates/authentic2/manager/user_imports.html      | 2 +-
 src/authentic2/manager/templates/authentic2/manager/users.html  | 2 +-
 src/authentic2/templates/authentic2/login.html                  | 2 +-
 src/authentic2/templates/authentic2/login_password_form.html    | 2 +-
 src/authentic2_auth_fc/templates/authentic2_auth_fc/base.html   | 2 +-
 .../templates/authentic2_auth_fc/linking.html                   | 2 +-
 src/authentic2_auth_fc/templates/authentic2_auth_fc/login.html  | 2 +-
 src/authentic2_auth_fc/templates/authentic2_auth_fc/unlink.html | 2 +-
 22 files changed, 22 insertions(+), 22 deletions(-)

diff --git a/src/authentic2/manager/templates/authentic2/manager/base.html b/src/authentic2/manager/templates/authentic2/manager/base.html
index 1b09acd6e..38fadbd45 100644
--- a/src/authentic2/manager/templates/authentic2/manager/base.html
+++ b/src/authentic2/manager/templates/authentic2/manager/base.html
@@ -1,5 +1,5 @@
 {% extends "gadjo/base.html" %}
-{% load i18n staticfiles %}
+{% load i18n static %}
 
 {% block gadjo-js %}{% endblock %}
 {% block bodyargs %} class="{% block bodyclasses %}{% endblock %}"{% endblock %}
diff --git a/src/authentic2/manager/templates/authentic2/manager/ou_common.html b/src/authentic2/manager/templates/authentic2/manager/ou_common.html
index 4c5d67890..784b54a97 100644
--- a/src/authentic2/manager/templates/authentic2/manager/ou_common.html
+++ b/src/authentic2/manager/templates/authentic2/manager/ou_common.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/base.html" %}
-{% load i18n staticfiles %}
+{% load i18n static %}
 
 {% block title %}{{ block.super }} - {% trans "Organizational units" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/ous.html b/src/authentic2/manager/templates/authentic2/manager/ous.html
index 1344b18d5..90826f19f 100644
--- a/src/authentic2/manager/templates/authentic2/manager/ous.html
+++ b/src/authentic2/manager/templates/authentic2/manager/ous.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/ou_common.html" %}
-{% load i18n staticfiles django_tables2 %}
+{% load i18n static django_tables2 %}
 
 {% block page-title %}{{ block.super }} - {% trans "Organizational units" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/role_common.html b/src/authentic2/manager/templates/authentic2/manager/role_common.html
index 24e2b3ac2..3167b9d0c 100644
--- a/src/authentic2/manager/templates/authentic2/manager/role_common.html
+++ b/src/authentic2/manager/templates/authentic2/manager/role_common.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/base.html" %}
-{% load i18n staticfiles %}
+{% load i18n static %}
 
 {% block title %}{{ block.super }} - {% trans "Roles" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/role_members.html b/src/authentic2/manager/templates/authentic2/manager/role_members.html
index 03ef96250..e77657a25 100644
--- a/src/authentic2/manager/templates/authentic2/manager/role_members.html
+++ b/src/authentic2/manager/templates/authentic2/manager/role_members.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/role_common.html" %}
-{% load i18n staticfiles django_tables2 %}
+{% load i18n static django_tables2 %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/role_permissions.html b/src/authentic2/manager/templates/authentic2/manager/role_permissions.html
index 95708862d..b01f2033f 100644
--- a/src/authentic2/manager/templates/authentic2/manager/role_permissions.html
+++ b/src/authentic2/manager/templates/authentic2/manager/role_permissions.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/role_common.html" %}
-{% load i18n staticfiles django_tables2 %}
+{% load i18n static django_tables2 %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/roles.html b/src/authentic2/manager/templates/authentic2/manager/roles.html
index f4c5f6708..9d668bf32 100644
--- a/src/authentic2/manager/templates/authentic2/manager/roles.html
+++ b/src/authentic2/manager/templates/authentic2/manager/roles.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/role_common.html" %}
-{% load i18n staticfiles django_tables2 %}
+{% load i18n static django_tables2 %}
 
 {% block page-title %}{{ block.super }} - {% trans "Roles" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/service.html b/src/authentic2/manager/templates/authentic2/manager/service.html
index a7830f1f9..eeae022d5 100644
--- a/src/authentic2/manager/templates/authentic2/manager/service.html
+++ b/src/authentic2/manager/templates/authentic2/manager/service.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/services.html" %}
-{% load i18n staticfiles django_tables2 %}
+{% load i18n static django_tables2 %}
 
 {% block breadcrumb %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/services.html b/src/authentic2/manager/templates/authentic2/manager/services.html
index cf7fdc9b9..a28d518dd 100644
--- a/src/authentic2/manager/templates/authentic2/manager/services.html
+++ b/src/authentic2/manager/templates/authentic2/manager/services.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/base.html" %}
-{% load i18n staticfiles django_tables2 %}
+{% load i18n static django_tables2 %}
 
 {% block page-title %}{{ block.super }} - {% trans "Services" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_authorizations.html b/src/authentic2/manager/templates/authentic2/manager/user_authorizations.html
index ddd340a7b..621b2db7d 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_authorizations.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_authorizations.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/base.html" %}
-{% load i18n staticfiles django_tables2 %}
+{% load i18n static django_tables2 %}
 
 {% block page-title %}{{ block.super }} - {% trans "Users" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_detail.html b/src/authentic2/manager/templates/authentic2/manager/user_detail.html
index c56cfb014..cfd8d5627 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_detail.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_detail.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/form.html" %}
-{% load i18n staticfiles %}
+{% load i18n static %}
 
 {% block appbar %}
   {{ block.super }}
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_export.html b/src/authentic2/manager/templates/authentic2/manager/user_export.html
index f66ebb710..7cbf62001 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_export.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_export.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/base.html" %}
-{% load i18n gadjo staticfiles %}
+{% load i18n gadjo static %}
 
 {% block page-title %}{{ block.super }} - {% trans "User export" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_import.html b/src/authentic2/manager/templates/authentic2/manager/user_import.html
index 80b9b2d70..ae70ace03 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_import.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_import.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/base.html" %}
-{% load i18n gadjo staticfiles %}
+{% load i18n gadjo static %}
 
 {% block page-title %}{{ block.super }} - {% trans "Import Users" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_import_report.html b/src/authentic2/manager/templates/authentic2/manager/user_import_report.html
index 4adf7a9b7..04982a443 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_import_report.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_import_report.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/base.html" %}
-{% load i18n gadjo staticfiles %}
+{% load i18n gadjo static %}
 
 {% block page-title %}{{ block.super }} - {% trans "Import Users" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/user_imports.html b/src/authentic2/manager/templates/authentic2/manager/user_imports.html
index c4825a5f1..79627fb22 100644
--- a/src/authentic2/manager/templates/authentic2/manager/user_imports.html
+++ b/src/authentic2/manager/templates/authentic2/manager/user_imports.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/base.html" %}
-{% load i18n gadjo staticfiles %}
+{% load i18n gadjo static %}
 
 {% block page-title %}{{ block.super }} - {% trans "Import Users" %}{% endblock %}
 
diff --git a/src/authentic2/manager/templates/authentic2/manager/users.html b/src/authentic2/manager/templates/authentic2/manager/users.html
index 5aeb2c003..4bba0eae7 100644
--- a/src/authentic2/manager/templates/authentic2/manager/users.html
+++ b/src/authentic2/manager/templates/authentic2/manager/users.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/manager/base.html" %}
-{% load i18n staticfiles django_tables2 %}
+{% load i18n static django_tables2 %}
 
 {% block page-title %}{{ block.super }} - {% trans "Users" %}{% endblock %}
 
diff --git a/src/authentic2/templates/authentic2/login.html b/src/authentic2/templates/authentic2/login.html
index e5282289a..1033333f4 100644
--- a/src/authentic2/templates/authentic2/login.html
+++ b/src/authentic2/templates/authentic2/login.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/base-page.html" %}
-{% load i18n gadjo staticfiles %}
+{% load i18n gadjo static %}
 
 {% block gadjo-jquery %}{% endblock %}
 
diff --git a/src/authentic2/templates/authentic2/login_password_form.html b/src/authentic2/templates/authentic2/login_password_form.html
index 97fcd89b7..580a82622 100644
--- a/src/authentic2/templates/authentic2/login_password_form.html
+++ b/src/authentic2/templates/authentic2/login_password_form.html
@@ -1,4 +1,4 @@
-{% load i18n staticfiles gadjo %}
+{% load i18n static gadjo %}
 
 {% block login %}
 
diff --git a/src/authentic2_auth_fc/templates/authentic2_auth_fc/base.html b/src/authentic2_auth_fc/templates/authentic2_auth_fc/base.html
index e51e93bc5..eab2a09a5 100644
--- a/src/authentic2_auth_fc/templates/authentic2_auth_fc/base.html
+++ b/src/authentic2_auth_fc/templates/authentic2_auth_fc/base.html
@@ -1,5 +1,5 @@
 {% extends "authentic2/base-page.html"%}
-{% load staticfiles %}
+{% load static %}
 
 {% block extra-css %}
 <link rel="stylesheet" type="text/css" href="{% static 'authentic2_auth_fc/css/fc.css' %}"></link>
diff --git a/src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html b/src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html
index 8bae41d84..3d61cdcda 100644
--- a/src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html
+++ b/src/authentic2_auth_fc/templates/authentic2_auth_fc/linking.html
@@ -1,4 +1,4 @@
-{% load staticfiles %}
+{% load static %}
 {% load i18n %}
 
 <link rel="stylesheet" type="text/css" href="{% static 'authentic2_auth_fc/css/fc.css' %}">
diff --git a/src/authentic2_auth_fc/templates/authentic2_auth_fc/login.html b/src/authentic2_auth_fc/templates/authentic2_auth_fc/login.html
index 20315b54a..0e29bc2a6 100644
--- a/src/authentic2_auth_fc/templates/authentic2_auth_fc/login.html
+++ b/src/authentic2_auth_fc/templates/authentic2_auth_fc/login.html
@@ -1,4 +1,4 @@
-{% load staticfiles %}
+{% load static %}
 {% load i18n %}
 
 {% block login %}
diff --git a/src/authentic2_auth_fc/templates/authentic2_auth_fc/unlink.html b/src/authentic2_auth_fc/templates/authentic2_auth_fc/unlink.html
index e9f2ec1b5..e42a707d5 100644
--- a/src/authentic2_auth_fc/templates/authentic2_auth_fc/unlink.html
+++ b/src/authentic2_auth_fc/templates/authentic2_auth_fc/unlink.html
@@ -1,5 +1,5 @@
 {% extends "authentic2_auth_fc/base.html"%}
-{% load staticfiles %}
+{% load static %}
 {% load i18n gadjo %}
 
 {% block content %}
-- 
2.31.0